<?php

include_once '../sys/inc/start.php';
include_once COMPRESS;
include_once SESS;
include_once '../sys/inc/home.php';
include_once SETTINGS;
include_once DB_CONNECT;
include_once IPUA;
include_once FNC;
include_once USER;

user_access('adm_news', null, 'index.php?' . SID);

if (!isset($_GET['id']) && !is_numeric($_GET['id'])) {
    header("Location: index.php?" . SID);
    exit;
}

if (dbresult(dbquery("SELECT COUNT(*) FROM `news` WHERE `id` = '" . intval($_GET['id']) . "' LIMIT 1", $db), 0) == 0) {
    header("Location: index.php?" . SID);
    exit;
}

$news = dbassoc(dbquery("SELECT * FROM `news` WHERE `id` = '" . intval($_GET['id']) . "' LIMIT 1"));

if (isset($_POST['view'])) {
    $news['title'] = $_POST['title'];
    $news['msg'] = $_POST['msg'];
    $news['link'] = $_POST['link'];
    $news['id_user'] = $user['id'];
}

if (isset($_POST['title']) && isset($_POST['msg']) && isset($_POST['link']) && isset($_POST['ok'])) {
    $title = esc($_POST['title'], 1);
    $link = esc($_POST['link'], 1);

    if ($link != NULL && !preg_match('#^https?://#', $link) && !preg_match('#^/#i', $link)) {
        $link = '/' . $link;
    }

    $msg = esc($_POST['msg']);

    if (strlen2($title) > 50) {
        $err = 'Слишком большой заголовок новости';
    }
    if (strlen2($title) < 3) {
        $err = 'Короткий заголовок';
    }

    $mat = antimat($title);

    if ($mat) {
        $err[] = 'В заголовке новости обнаружен мат: ' . $mat;
    }

    if (strlen2($msg) > 10024) {
        $err = 'Содержиние новости слишком большое';
    }

    if (strlen2($msg) < 2) {
        $err = 'Новость слишком короткая';
    }

    $mat = antimat($msg);

    if ($mat) {
        $err[] = 'В содержании обнаружен мат: ' . $mat;
    }

    $title = my_esc($_POST['title']);
    $msg = my_esc($_POST['msg']);

    if (!isset($err)) {
        $ch = intval($_POST['ch']);
        $mn = intval($_POST['mn']);
        $main_time = time() + $ch * $mn * 60 * 60 * 24;

        if ($main_time <= time()) {
            $main_time = 0;
        }

        dbquery("UPDATE `news` SET `title` = '$title', `msg` = '$msg', `link` = '$link', `main_time` = '$main_time', `time` = '$time' WHERE `id` = '$news[id]' LIMIT 1");
        dbquery("UPDATE `user` SET `news_read` = '0'");

        $_SESSION['message'] = 'Изменения сохранены';

        header("Location: news.php?id=$news[id]");
        exit;
    }
}

$set['title'] = 'Новости - редактирование';
include_once THEAD;

title();
err();
aut(); // форма авторизации

echo '<div class="list-group">';

if (isset($_POST['view']) && !isset($err)) {

    echo '<div class="list-group-item list-group-item-warning">';
    echo "<h3>" . text($news['title']) . "</h3>";

    echo output_text($news['msg']) . '<br />';

    if ($news['link'] != NULL) {
        echo '<a href="' . htmlentities($news['link'], ENT_QUOTES, 'UTF-8') . '">Источник</a>';
    }
    echo '</div>';
}

echo '<form class="list-group-item" method="post" name="message" action="?id=' . $news['id'] . '">';
echo "<div class='mb-3'>";
echo "<label class='form-label'>Заголовок новости:</label>";
echo '<input name="title" class="form-control" value="' . text($news['title']) . '" type="text" />';
echo '</div>';

$insert = text($news['msg']);

echo "<div class='mb-3'>";
echo "<label class='form-label'>Сообщение:</label>";
echo '' . $tPanel . ' <textarea name="msg" class="form-control">' . $insert . '</textarea>';
echo '</div>';

echo "<div class='mb-3'>";
echo "<label class='form-label'>Ссылка:</label>";
echo '<input name="link" class="form-control" value="' . text($news['link']) . '" type="text" />';
echo '</div>';

echo "<div class='mb-3'>";
echo 'Показывать на главной:<br />';
echo "<div class='input-group mb-3'>";
echo '<input type="text" name="ch" size="3" class="form-control" value="' . (isset($_POST['ch']) ? intval($_POST['ch']) : "1") . '" />';
echo '<select name="mn" class="form-control">';
echo '  <option value="0" ' . (isset($_POST['mn']) && $_POST['mn'] == 0 ? "selected='selected'" : null) . '>Не показывать</option>';
echo '  <option value="1" ' . (isset($_POST['mn']) && $_POST['mn'] == 1 ? "selected='selected'" : null) . '>Дней</option>';
echo '  <option value="7" ' . (isset($_POST['mn']) && $_POST['mn'] == 7 ? "selected='selected'" : null) . '>Недель</option>';
echo '  <option value="31" ' . (isset($_POST['mn']) && $_POST['mn'] == 31 ? "selected='selected'" : null) . '>Месяцев</option>';
echo '</select>';
echo '</div>';
echo '</div>';

echo "<button type='submit' class='btn btn-primary' name='view'><i class='mdi mdi-eye-outline'></i> Просмотр</button>\n";
echo "<button type='submit' class='btn btn-success' name='ok'><i class='mdi mdi-check'></i> Готово</button>\n";
echo '</form>';

echo'<div class="list-group-item">';
echo '<i class="mdi mdi-arrow-left"></i> <a href="index.php">Новости</a> | <a href="news.php?id=' . $news['id'] . '">' . text($news['title']) . '</a>';
echo '</div>';
echo '</div>';

include_once TFOOT;
?>